// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: upsert_signature.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const upsertSignature = `-- name: UpsertSignature :exec

WITH upsert_peer AS (
    INSERT INTO peers.peers (id)
        VALUES ($1)
        ON CONFLICT DO NOTHING
),
upsert_cert AS (
    INSERT INTO peers.certificates (
        certificate_thumbprint,
        certificate,
        peer_id
    )
    VALUES ($2, $3, $1)
    ON CONFLICT DO NOTHING
)
INSERT INTO contracts.contract_signatures (
    content_hash,
    signature_type,
    signature,
    peer_id,
    certificate_thumbprint,
    signed_at
)
VALUES ($4, $5, $6, $1, $2, $7)
ON CONFLICT DO NOTHING
`

type UpsertSignatureParams struct {
	PeerID                string
	CertificateThumbprint string
	Certificate           []byte
	ContentHash           string
	SignatureType         ContractsSignatureType
	Signature             string
	SignedAt              pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2022
// Licensed under the EUPL
func (q *Queries) UpsertSignature(ctx context.Context, arg *UpsertSignatureParams) error {
	_, err := q.db.Exec(ctx, upsertSignature,
		arg.PeerID,
		arg.CertificateThumbprint,
		arg.Certificate,
		arg.ContentHash,
		arg.SignatureType,
		arg.Signature,
		arg.SignedAt,
	)
	return err
}
